#!/usr/bin/env python2
# coding: utf-8
import subprocess
import os
import locale
from gi.repository import Gio,GLib

def add_to_panel(desktop_path):
    i = 0
    panel_schema = Gio.Settings.new("org.mate.panel")
    applet_list = panel_schema.get_strv("object-id-list")

    while (i < len(applet_list)):
        test_obj = "object_%d" % (i)
        if test_obj in applet_list:
            path = "/org/mate/panel/objects/%s/" % (test_obj)
            new_schema = Gio.Settings.new_with_path("org.mate.panel.object", path)
            if (new_schema.get_string("launcher-location") == desktop_path):
                return
        i += 1

    i = 0
    while True:
        test_obj = "object_%d" % (i)
        if test_obj in applet_list:
            i += 1
        else:
            break
    
    path = "/org/mate/panel/objects/%s/" % (test_obj)
    new_schema = Gio.Settings.new_with_path("org.mate.panel.object", path)
    new_schema.set_string("launcher-location", desktop_path)
    new_schema.set_string("object-type", "launcher")
    new_schema.set_string("toplevel-id", "bottom")
    new_schema.set_int("position", 50)
    applet_list.append(test_obj)
    panel_schema.set_strv("object-id-list", applet_list)

def delete_from_panel(desktop_path):
    i=0
    panel_schema = Gio.Settings.new("org.mate.panel")
    applet_list = panel_schema.get_strv("object-id-list")
    while (i < len(applet_list)):
        test_obj = "object_%d" % (i)
        if test_obj in applet_list:
            path = "/org/mate/panel/objects/%s/" % (test_obj)
            new_schema = Gio.Settings.new_with_path("org.mate.panel.object", path)
            if (new_schema.get_string("launcher-location") == desktop_path):
                applet_list.remove(test_obj)
                panel_schema.set_strv("object-id-list", applet_list)
        i += 1

def directory_changed(monitor, file1, file2, evt_type):
    if (not file1.get_path().endswith(".desktop")):
        return
    dekstopdir = GLib.get_user_special_dir(GLib.USER_DIRECTORY_DESKTOP)
    if evt_type == Gio.FileMonitorEvent.CREATED:
        if file1 != None:
            add_to_panel(file1.get_path())
            status = subprocess.call('cp '+file1.get_path() + ' ' + dekstopdir,shell=True)
            os.system("chmod +x "+dekstopdir +"/"+ file1.get_basename())
    if evt_type == Gio.FileMonitorEvent.DELETED:
        if file1 != None:
            delete_from_panel(file1.get_path())
            if os.path.exists(dekstopdir +"/" + file1.get_basename()):
                os.remove(dekstopdir +"/" + file1.get_basename())
            
gfile = Gio.File.new_for_path("/usr/share/applications")
monitor = gfile.monitor_directory(Gio.FileMonitorFlags.NONE, None)
monitor.connect("changed", directory_changed) 
 
ml = GLib.MainLoop()
ml.run()
